/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __optest_RecordOp_h__
#define __optest_RecordOp_h__

namespace fe
{

/**************************************************************************//**
	@brief Save a mesh as a RecordGroup

	@ingroup optest
*//***************************************************************************/
class FE_DL_EXPORT RecordOp:
	public OperatorSurfaceCommon,
	public Initialize<RecordOp>
{
	public:

	class Handler:
		public ObjectSafeShared<Handler>,
		virtual public HandlerI,
		virtual public BindI
	{
		public:
					Handler(void)											{}
	virtual			~Handler(void)											{}

	virtual	void	handle(Record &a_signal);

	virtual	void	bind(sp<SignalerI> spSignaler,sp<Layout> spLayout)		{}

			void	bind(sp<RecordOp> a_spRecordOp)
					{	m_hpRecordOp=a_spRecordOp; }

			String	state(void) const;
			void	setState(String a_state);

			Record	record(void) const;

			void	setSelf(String a_source)	{ m_self=a_source; }

		private:
			hp<RecordOp>		m_hpRecordOp;
			String				m_self;
			String				m_state;
			Record				m_record;
	};

					RecordOp(void):
						m_brushed(FALSE),
						m_lastFrame(0.0)									{}
virtual				~RecordOp(void)											{}

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);

		Accessor<int>		m_ttl;
		Accessor<String>	m_source;
		Accessor<String>	m_text;
		Accessor<Record>	m_model;

	private:
		BWORD				m_brushed;
		Real				m_lastFrame;

		sp<Scope>			m_spScope;
		sp<Layout>			m_spLayoutHB;
		sp<Layout>			m_spLayoutMessage;
		sp<Layout>			m_spLayoutSurface;

		sp<SignalerI>		m_spSignaler;
		sp<Handler>			m_spHandler;
		sp<ServerI>			m_spServer;
		sp<ClientI>			m_spClient;
};

} /* namespace */

#endif /* __optest_RecordOp_h__ */
